# coding: utf-8

"""
    Jellyfin API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 10.11.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.lyric_line import LyricLine
from openapi_client.models.lyric_metadata import LyricMetadata
from typing import Optional, Set
from typing_extensions import Self

class LyricDto(BaseModel):
    """
    LyricResponse model.
    """ # noqa: E501
    metadata: Optional[LyricMetadata] = Field(default=None, description="Gets or sets Metadata for the lyrics.", alias="Metadata")
    lyrics: Optional[List[LyricLine]] = Field(default=None, description="Gets or sets a collection of individual lyric lines.", alias="Lyrics")
    __properties: ClassVar[List[str]] = ["Metadata", "Lyrics"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LyricDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['Metadata'] = self.metadata.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in lyrics (list)
        _items = []
        if self.lyrics:
            for _item_lyrics in self.lyrics:
                if _item_lyrics:
                    _items.append(_item_lyrics.to_dict())
            _dict['Lyrics'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LyricDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Metadata": LyricMetadata.from_dict(obj["Metadata"]) if obj.get("Metadata") is not None else None,
            "Lyrics": [LyricLine.from_dict(_item) for _item in obj["Lyrics"]] if obj.get("Lyrics") is not None else None
        })
        return _obj


