# coding: utf-8

"""
    Jellyfin API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 10.11.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MetadataOptions(BaseModel):
    """
    Class MetadataOptions.
    """ # noqa: E501
    item_type: Optional[StrictStr] = Field(default=None, alias="ItemType")
    disabled_metadata_savers: Optional[List[StrictStr]] = Field(default=None, alias="DisabledMetadataSavers")
    local_metadata_reader_order: Optional[List[StrictStr]] = Field(default=None, alias="LocalMetadataReaderOrder")
    disabled_metadata_fetchers: Optional[List[StrictStr]] = Field(default=None, alias="DisabledMetadataFetchers")
    metadata_fetcher_order: Optional[List[StrictStr]] = Field(default=None, alias="MetadataFetcherOrder")
    disabled_image_fetchers: Optional[List[StrictStr]] = Field(default=None, alias="DisabledImageFetchers")
    image_fetcher_order: Optional[List[StrictStr]] = Field(default=None, alias="ImageFetcherOrder")
    __properties: ClassVar[List[str]] = ["ItemType", "DisabledMetadataSavers", "LocalMetadataReaderOrder", "DisabledMetadataFetchers", "MetadataFetcherOrder", "DisabledImageFetchers", "ImageFetcherOrder"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MetadataOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if item_type (nullable) is None
        # and model_fields_set contains the field
        if self.item_type is None and "item_type" in self.model_fields_set:
            _dict['ItemType'] = None

        # set to None if disabled_metadata_savers (nullable) is None
        # and model_fields_set contains the field
        if self.disabled_metadata_savers is None and "disabled_metadata_savers" in self.model_fields_set:
            _dict['DisabledMetadataSavers'] = None

        # set to None if local_metadata_reader_order (nullable) is None
        # and model_fields_set contains the field
        if self.local_metadata_reader_order is None and "local_metadata_reader_order" in self.model_fields_set:
            _dict['LocalMetadataReaderOrder'] = None

        # set to None if disabled_metadata_fetchers (nullable) is None
        # and model_fields_set contains the field
        if self.disabled_metadata_fetchers is None and "disabled_metadata_fetchers" in self.model_fields_set:
            _dict['DisabledMetadataFetchers'] = None

        # set to None if metadata_fetcher_order (nullable) is None
        # and model_fields_set contains the field
        if self.metadata_fetcher_order is None and "metadata_fetcher_order" in self.model_fields_set:
            _dict['MetadataFetcherOrder'] = None

        # set to None if disabled_image_fetchers (nullable) is None
        # and model_fields_set contains the field
        if self.disabled_image_fetchers is None and "disabled_image_fetchers" in self.model_fields_set:
            _dict['DisabledImageFetchers'] = None

        # set to None if image_fetcher_order (nullable) is None
        # and model_fields_set contains the field
        if self.image_fetcher_order is None and "image_fetcher_order" in self.model_fields_set:
            _dict['ImageFetcherOrder'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MetadataOptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ItemType": obj.get("ItemType"),
            "DisabledMetadataSavers": obj.get("DisabledMetadataSavers"),
            "LocalMetadataReaderOrder": obj.get("LocalMetadataReaderOrder"),
            "DisabledMetadataFetchers": obj.get("DisabledMetadataFetchers"),
            "MetadataFetcherOrder": obj.get("MetadataFetcherOrder"),
            "DisabledImageFetchers": obj.get("DisabledImageFetchers"),
            "ImageFetcherOrder": obj.get("ImageFetcherOrder")
        })
        return _obj


