# coding: utf-8

"""
    Jellyfin API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 10.11.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.playstate_command import PlaystateCommand
from typing import Optional, Set
from typing_extensions import Self

class PlaystateRequest(BaseModel):
    """
    PlaystateRequest
    """ # noqa: E501
    command: Optional[PlaystateCommand] = Field(default=None, description="Enum PlaystateCommand.", alias="Command")
    seek_position_ticks: Optional[StrictInt] = Field(default=None, alias="SeekPositionTicks")
    controlling_user_id: Optional[StrictStr] = Field(default=None, description="Gets or sets the controlling user identifier.", alias="ControllingUserId")
    __properties: ClassVar[List[str]] = ["Command", "SeekPositionTicks", "ControllingUserId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PlaystateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if seek_position_ticks (nullable) is None
        # and model_fields_set contains the field
        if self.seek_position_ticks is None and "seek_position_ticks" in self.model_fields_set:
            _dict['SeekPositionTicks'] = None

        # set to None if controlling_user_id (nullable) is None
        # and model_fields_set contains the field
        if self.controlling_user_id is None and "controlling_user_id" in self.model_fields_set:
            _dict['ControllingUserId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PlaystateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Command": obj.get("Command"),
            "SeekPositionTicks": obj.get("SeekPositionTicks"),
            "ControllingUserId": obj.get("ControllingUserId")
        })
        return _obj


