# coding: utf-8

"""
    Jellyfin API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 10.11.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.session_message_type import SessionMessageType
from openapi_client.models.timer_event_info import TimerEventInfo
from typing import Optional, Set
from typing_extensions import Self

class SeriesTimerCancelledMessage(BaseModel):
    """
    Series timer cancelled message.
    """ # noqa: E501
    data: Optional[TimerEventInfo] = Field(default=None, description="Gets or sets the data.", alias="Data")
    message_id: Optional[StrictStr] = Field(default=None, description="Gets or sets the message id.", alias="MessageId")
    message_type: Optional[SessionMessageType] = Field(default=SessionMessageType.SERIESTIMERCANCELLED, description="The different kinds of messages that are used in the WebSocket api.", alias="MessageType")
    __properties: ClassVar[List[str]] = ["Data", "MessageId", "MessageType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SeriesTimerCancelledMessage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "message_type",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict['Data'] = self.data.to_dict()
        # set to None if data (nullable) is None
        # and model_fields_set contains the field
        if self.data is None and "data" in self.model_fields_set:
            _dict['Data'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SeriesTimerCancelledMessage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Data": TimerEventInfo.from_dict(obj["Data"]) if obj.get("Data") is not None else None,
            "MessageId": obj.get("MessageId"),
            "MessageType": obj.get("MessageType") if obj.get("MessageType") is not None else SessionMessageType.SERIESTIMERCANCELLED
        })
        return _obj


