# coding: utf-8

"""
    Jellyfin API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 10.11.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateUserPassword(BaseModel):
    """
    The update user password request body.
    """ # noqa: E501
    current_password: Optional[StrictStr] = Field(default=None, description="Gets or sets the current sha1-hashed password.", alias="CurrentPassword")
    current_pw: Optional[StrictStr] = Field(default=None, description="Gets or sets the current plain text password.", alias="CurrentPw")
    new_pw: Optional[StrictStr] = Field(default=None, description="Gets or sets the new plain text password.", alias="NewPw")
    reset_password: Optional[StrictBool] = Field(default=None, description="Gets or sets a value indicating whether to reset the password.", alias="ResetPassword")
    __properties: ClassVar[List[str]] = ["CurrentPassword", "CurrentPw", "NewPw", "ResetPassword"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateUserPassword from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if current_password (nullable) is None
        # and model_fields_set contains the field
        if self.current_password is None and "current_password" in self.model_fields_set:
            _dict['CurrentPassword'] = None

        # set to None if current_pw (nullable) is None
        # and model_fields_set contains the field
        if self.current_pw is None and "current_pw" in self.model_fields_set:
            _dict['CurrentPw'] = None

        # set to None if new_pw (nullable) is None
        # and model_fields_set contains the field
        if self.new_pw is None and "new_pw" in self.model_fields_set:
            _dict['NewPw'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateUserPassword from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CurrentPassword": obj.get("CurrentPassword"),
            "CurrentPw": obj.get("CurrentPw"),
            "NewPw": obj.get("NewPw"),
            "ResetPassword": obj.get("ResetPassword")
        })
        return _obj


